defmodule Commanded do
  @moduledoc """
  Use Commanded to build your own Elixir applications following the CQRS/ES pattern.

  Provides support for:

  - [Command registration and dispatch](commands.html).
  - [Hosting and delegation to aggregate roots](aggregate-roots.html).
  - [Event handling](events.html).
  - [Long running process managers](process-managers.html).

  Use Commanded with one of the following event stores for persistence:

  - [EventStore](hex.pm/packages/eventstore) Elixir library, using PostgreSQL for persistence
  - Greg Young's [Event Store](https://geteventstore.com/).

  Please check the [Getting Started](getting-started.html) and [Usage](usage.html) guides to learn more.
  """
end
